Main Page Namespace List Class Hierarchy Compound List File List Namespace Members Compound Members File Members Related Pages

# SGNode Class Reference

Represents a branch/node of a shock graph. More...

`#include <SGNode.h>`

Inheritance diagram for SGNode:

List of all members.

## Public Methods
virtual DAGNode * | CreateObject () const
| SGNode (String szId, int nType)
| Constructor from data.
virtual void | ComputeDerivedValues ()
void | ComputeSpeeds ()
| Compute speeds very roughly as consecutive differences.
virtual void | Clear ()
| Initializes the contents of the object to their original values.
virtual DAGNode & | operator= (const DAGNode &rhs)
| Extends the behaviour of the same function in the base class.
virtual void | Print (ostream &os=cout) const
| Extends the behaviour of the same function in the base class.
virtual istream & | Read (istream &is)
| Extends the behaviour of the same function in the base class.
virtual ostream & | Write (ostream &os) const
| Extends the behaviour of the same function in the base class.
virtual NODE_LABEL | GetLblForGraph () const
| Returns the label that will be displayed in the graph.
virtual leda_color | GetColorForGraph () const
| Returns the color that will be displayed in the graph.
virtual int | GetShapeForGraph () const
| Returns the shape for the node in the graph.
## Public Attributes
int | m_nType
| Shock branch type (1, 2, 3, 4).
char | m_cEndPt
| Whether is 3a, 3b, and so on (vals: 0, 'a', 'b').
double | m_seg2
| Contour segment's lengths.
String | m_strBranchId
| Id to distinguish from others of this kind.
ShockBranch | m_shocks
| array of shocks that belong to the branch (branch points).

## Detailed Description

Represents a branch/node of a shock graph.

Todo:
  At this moment, the type of a branch is not 1..4 but instead the set of numbers that the shock graph detection algorithm returns. SHOCK_base=100, SHOCK_2or3=100, SHOCK_1=101, SHOCK_2=102, SHOCK_3=103, SHOCK_4=104, ROOT=105 (values defined in Shock.h).

See also:
  DAGNode, ShockGraph.

Definition at line 222 of file SGNode.h.

## Member Function Documentation

void SGNode::ComputeDerivedValues | ( |  | ) | `[virtual]`

| Computes the node's TSV norm considering that the TSV includes the eigenvalue of the node too. Reimplemented from DAGNode. Definition at line 160 of file SGNode.cpp. References DAGNode::ComputeDerivedValues(), and m_shocks. Referenced by ShockGraph::GroupShockPoints(), and ShockGraph::Insert4sAnd2s().

DAGNode * SGNode::CreateObject | ( |  | ) | const`[virtual]`

| Creates a new SGNode with a copy of the information conatines in 'this'. This functions is required by SmartPtr<DAGNode*>::operator[]. Implements DAGNode. Definition at line 93 of file SGNode.cpp. References SGNode().

int SGNode::GetShapeForGraph | ( |  | ) | const`[virtual]`

| Returns the shape for the node in the graph. See graphwin.h line #160 for the 'enum' node shape options. Reimplemented from DAGNode. Definition at line 265 of file SGNode.cpp.

The documentation for this class was generated from the following files:

- SGNode.h
- SGNode.cpp